@echo off
setlocal
pushd .
cd /d "%~f0\.."

set "tmp_installreg=%TMP%\copy_path_install.reg"
if not %PROCESSOR_ARCHITECTURE% == AMD64 goto :bits32
set "install_dir=%ProgramFiles(x86)%\copypath"
goto :f
:bits32
set install_dir=%ProgramFiles%\copypath
:f
set "install_dir_regstring=%install_dir:\=\\%"

echo This will install Copy Path, a simple program that allows you to copy the
echo path to a file or directory by simply right-clicking it in the Windows Explorer
echo and choosing 'Copy Path'.
echo.
echo NOTE: This installation program should be run with administrator privileges.
echo.
echo Press any key to continue the installation process...
pause >nul

if exist "%install_dir%" goto :e_exist

mkdir "%install_dir%" || goto :error
copy data\copypath.exe "%install_dir%" >nul || goto :error

echo Windows Registry Editor Version 5.00>"%tmp_installreg%"
echo.>>"%tmp_installreg%"
echo [HKEY_CLASSES_ROOT\*\shell\CopyPath]>>"%tmp_installreg%"
echo @="Copy P&ath">>"%tmp_installreg%"
echo.>>"%tmp_installreg%"
echo [HKEY_CLASSES_ROOT\*\shell\CopyPath\command]>>"%tmp_installreg%"
echo @="%install_dir_regstring%\\copypath.exe \"%%1\"">>"%tmp_installreg%"
echo.>>"%tmp_installreg%"
echo [HKEY_CLASSES_ROOT\Directory\shell\CopyPath]>>"%tmp_installreg%"
echo @="Copy P&ath">>"%tmp_installreg%"
echo.>>"%tmp_installreg%"
echo [HKEY_CLASSES_ROOT\Directory\shell\CopyPath\command]>>"%tmp_installreg%"
echo @="%install_dir_regstring%\\copypath.exe \"%%1\"">>"%tmp_installreg%"
regedit /s "%tmp_installreg%"

echo Installation complete.
goto :exit

:e_exist
echo The file or directory `%install_dir%' already exists.>&2
echo The installation program can't install the program to this directory.>&2
goto :exit

:error
echo Installation failed.>&2
echo Are you logged on as an administrator?>&2
goto :exit

:exit
popd
endlocal

echo Press any key to exit the installation program...
pause >nul
